/*!
 * KoliBri - The accessible HTML-Standard
 */
import{r as registerInstance,h,H as Host,g as getElement}from"./index-62e5924b.js";import{L as Log,B as watchBoolean,A as validateHasCloser,v as validateLabel,m as setState,w as watchValidator,aF as alertTypeOptions,aG as alertVariantOptions,aH as mapBoolean2String,aI as mapStringOrBoolean2String,k as propagateFocus,a9 as setEventTarget,ax as validateAccessKey,aJ as validateAriaControls,aK as validateAriaExpanded,aL as validateAriaSelected,ai as validateCustomClass,l as validateDisabled,R as validateHideLabel,aA as validateIcons,C as watchString,U as validateLabelWithExpertSlot,aM as validateButtonCallbacks,aC as validateAlternativeButtonLinkRole,V as validateTabIndex,i as validateTooltipAlign,aN as validateButtonType,aO as validateButtonVariant,M as showExpertSlot,aP as validateHeadingVariant}from"./index-de9d4ee0.js";import{a as translate}from"./i18n-8b7a6ddc.js";import{w as watchHeadingLevel}from"./validation-6a9d569a.js";import{s as stopPropagation,t as tryToDispatchKoliBriEvent}from"./events-29e84d75.js";import{p as propagateSubmitEventToForm,a as propagateResetEventToForm}from"./controller-ec7c96d6.js";import{A as AssociatedInputController}from"./associated.controller-3f6bde32.js";import"./index-8cb3c3b2.js";import"./dev.utils-744f41b3.js";const Icon=a=>h("kol-icon",{class:"heading-icon",_label:"string"==typeof a.label&&a.label.length>0?"":a.ariaLabel,_icons:a.icon}),AlertIcon=a=>{switch(a.type){case"error":return h(Icon,{ariaLabel:translate("kol-error"),icon:"codicon codicon-error",label:a.label});case"info":return h(Icon,{ariaLabel:translate("kol-info"),icon:"codicon codicon-info",label:a.label});case"warning":return h(Icon,{ariaLabel:translate("kol-warning"),icon:"codicon codicon-warning",label:a.label});case"success":return h(Icon,{ariaLabel:translate("kol-success"),icon:"codicon codicon-pass",label:a.label});default:return h(Icon,{ariaLabel:translate("kol-message"),icon:"codicon codicon-comment",label:a.label})}},KolAlertWc=class{constructor(a){registerInstance(this,a),this.close=()=>{var a;void 0!==(null===(a=this._on)||void 0===a?void 0:a.onClose)&&this._on.onClose(new Event("Close"))},this.on={onClick:this.close},this.validateOnValue=a=>"object"==typeof a&&null!==a&&"function"==typeof a.onClose,this._alert=!1,this._hasCloser=!1,this._label=void 0,this._level=1,this._on=void 0,this._type="default",this._variant="msg",this.state={_level:1}}render(){var a;if(this.state._alert){try{Log.debug(["Navigator should vibrate ...",navigator.vibrate([100,75,100,75,100])])}catch(a){Log.debug("Navigator does not support vibration.")}setTimeout((()=>{this.validateAlert(!1)}),1e4)}return h(Host,{key:"3b2f5ac6462c380e631c36367a2e55b7519ecbe6",class:{alert:!0,[this.state._type]:!0,[this.state._variant]:!0,hasCloser:!!this.state._hasCloser},role:this.state._alert?"alert":void 0},h("div",{key:"e805417410e1ff870e45c1eadb03d3d7203901b5",class:"heading"},h(AlertIcon,{key:"9705bf593034348a8aa47f7980c94deac6cac7db",label:this.state._label,type:this.state._type}),h("div",{key:"5360f5cc4ac1d3c3360a2517e0c934ddc21e57c6",class:"heading-content"},"string"==typeof this.state._label&&(null===(a=this.state._label)||void 0===a?void 0:a.length)>0&&h("kol-heading-wc",{_label:this.state._label,_level:this.state._level}),"msg"===this.state._variant&&h("div",{class:"content"},h("slot",null))),this.state._hasCloser&&h("kol-button-wc",{class:"close",_hideLabel:!0,_icons:{left:{icon:"codicon codicon-close"}},_label:translate("kol-close"),_on:this.on,_tooltipAlign:"left"})),"card"===this.state._variant&&h("div",{class:"content"},h("slot",null)))}validateAlert(a){watchBoolean(this,"_alert",a)}validateHasCloser(a){validateHasCloser(this,a)}validateLabel(a){validateLabel(this,a)}validateLevel(a){watchHeadingLevel(this,a)}validateOn(a){this.validateOnValue(a)&&setState(this,"_on",{onClose:a.onClose})}validateType(a){watchValidator(this,"_type",(a=>"string"==typeof a&&alertTypeOptions.includes(a)),new Set(`String {${alertTypeOptions.join(", ")}`),a)}validateVariant(a){watchValidator(this,"_variant",(a=>"string"==typeof a&&alertVariantOptions.includes(a)),new Set(`AlertVariant {${alertVariantOptions.join(", ")}`),a)}componentWillLoad(){this.validateAlert(this._alert),this.validateHasCloser(this._hasCloser),this.validateLabel(this._label),this.validateLevel(this._level),this.validateOn(this._on),this.validateType(this._type),this.validateVariant(this._variant)}static get watchers(){return{_alert:["validateAlert"],_hasCloser:["validateHasCloser"],_label:["validateLabel"],_level:["validateLevel"],_on:["validateOn"],_type:["validateType"],_variant:["validateVariant"]}}},KolButtonWc=class{render(){const a=showExpertSlot(this.state._label);return h(Host,{key:"6210753dd7db71f0a3df9e778cd1c526f95503d3"},h("button",Object.assign({key:"e1422d9e465b133e5328cbe0037b9378174b19e4",ref:this.catchRef,accessKey:this.state._accessKey||void 0,"aria-controls":this.state._ariaControls,"aria-expanded":mapBoolean2String(this.state._ariaExpanded),"aria-label":this.state._hideLabel&&"string"==typeof this.state._label?this.state._label:void 0,"aria-selected":mapStringOrBoolean2String(this.state._ariaSelected),class:{button:!0,disabled:!0===this.state._disabled,[this.state._variant]:"custom"!==this.state._variant,[this.state._customClass]:"custom"===this.state._variant&&"string"==typeof this.state._customClass&&this.state._customClass.length>0,"hide-label":!0===this.state._hideLabel},disabled:this.state._disabled,id:this.state._id,name:this.state._name},this.state._on,{onClick:this.onClick,role:this.state._role,tabIndex:this.state._tabIndex,type:this.state._type}),h("kol-span-wc",{key:"17436202d4fa5926b88734c2e0e59da6aeea3072",class:"button-inner",_accessKey:this.state._accessKey,_icons:this.state._icons,_hideLabel:this.state._hideLabel,_label:a?"":this.state._label},h("slot",{key:"59e7ae324b13a0ebc386f5d4cfc451b92a65c76c",name:"expert",slot:"expert"}))),h("kol-tooltip-wc",{key:"6b14c5d6852abfd4b6c692b9de9e58928f7ba0ba","aria-hidden":"true",hidden:a||!this.state._hideLabel,_accessKey:this._accessKey,_align:this.state._tooltipAlign,_label:"string"==typeof this.state._label?this.state._label:""}))}constructor(a){registerInstance(this,a),this.catchRef=a=>{this.ref=a,propagateFocus(this.host,this.ref)},this.onClick=a=>{var t,e;"submit"===this.state._type?propagateSubmitEventToForm({form:this.host,ref:this.ref}):"reset"===this.state._type?propagateResetEventToForm({form:this.host,ref:this.ref}):(stopPropagation(a),tryToDispatchKoliBriEvent("click",this.host,this.state._value),this.controller.setFormAssociatedValue(this.state._value),"function"==typeof(null===(t=this.state._on)||void 0===t?void 0:t.onClick)&&(setEventTarget(a,this.ref),null===(e=this.state._on)||void 0===e||e.onClick(a,this.state._value)))},this._accessKey=void 0,this._ariaControls=void 0,this._ariaExpanded=void 0,this._ariaSelected=void 0,this._customClass=void 0,this._disabled=!1,this._hideLabel=!1,this._icons=void 0,this._id=void 0,this._label=void 0,this._name=void 0,this._on=void 0,this._role=void 0,this._syncValueBySelector=void 0,this._tabIndex=void 0,this._tooltipAlign="top",this._type="button",this._value=void 0,this._variant="normal",this.state={_icons:{},_label:"",_on:{},_type:"button",_variant:"normal"},this.controller=new AssociatedInputController(this,"button",this.host)}validateAccessKey(a){validateAccessKey(this,a)}validateAriaControls(a){validateAriaControls(this,a)}validateAriaExpanded(a){validateAriaExpanded(this,a)}validateAriaSelected(a){validateAriaSelected(this,a)}validateCustomClass(a){validateCustomClass(this,a)}validateDisabled(a){validateDisabled(this,a)}validateHideLabel(a){validateHideLabel(this,a)}validateIcons(a){validateIcons(this,a)}validateId(a){watchString(this,"_id",a)}validateLabel(a){validateLabelWithExpertSlot(this,a,{required:!0})}validateName(a){this.controller.validateName(a)}validateOn(a){validateButtonCallbacks(this,a)}validateRole(a){validateAlternativeButtonLinkRole(this,a)}validateSyncValueBySelector(a){this.controller.validateSyncValueBySelector(a)}validateTabIndex(a){validateTabIndex(this,a)}validateTooltipAlign(a){validateTooltipAlign(this,a)}validateType(a){validateButtonType(this,a)}validateValue(a){setState(this,"_value",a),this.controller.setFormAssociatedValue(this.state._value)}validateVariant(a){validateButtonVariant(this,a)}componentWillLoad(){this.validateAccessKey(this._accessKey),this.validateAriaControls(this._ariaControls),this.validateAriaExpanded(this._ariaExpanded),this.validateAriaSelected(this._ariaSelected),this.validateCustomClass(this._customClass),this.validateDisabled(this._disabled),this.validateHideLabel(this._hideLabel),this.validateIcons(this._icons),this.validateId(this._id),this.validateLabel(this._label),this.validateName(this._name),this.validateOn(this._on),this.validateRole(this._role),this.validateSyncValueBySelector(this._syncValueBySelector),this.validateTabIndex(this._tabIndex),this.validateTooltipAlign(this._tooltipAlign),this.validateType(this._type),this.validateValue(this._value),this.validateVariant(this._variant)}get host(){return getElement(this)}static get watchers(){return{_accessKey:["validateAccessKey"],_ariaControls:["validateAriaControls"],_ariaExpanded:["validateAriaExpanded"],_ariaSelected:["validateAriaSelected"],_customClass:["validateCustomClass"],_disabled:["validateDisabled"],_hideLabel:["validateHideLabel"],_icons:["validateIcons"],_id:["validateId"],_label:["validateLabel"],_name:["validateName"],_on:["validateOn"],_role:["validateRole"],_syncValueBySelector:["validateSyncValueBySelector"],_tabIndex:["validateTabIndex"],_tooltipAlign:["validateTooltipAlign"],_type:["validateType"],_value:["validateValue"],_variant:["validateVariant"]}}},KolHeadingWc=class{constructor(a){registerInstance(this,a),this.renderHeadline=(a,t)=>{const e="number"==typeof t&&t>0&&t<=6?`h${t}`:"strong",i=this._variant||e;return h(e,{class:{headline:!0,[`headline-${i}`]:!0}},a,h("slot",{name:"expert"}))},this.renderSecondaryHeadline=(a,t)=>{switch(t){case 1:return h("span",{class:"secondary-headline"},a);case 2:return h("h2",{class:"secondary-headline"},a);case 3:return h("h3",{class:"secondary-headline"},a);case 4:return h("h4",{class:"secondary-headline"},a);case 5:return h("h5",{class:"secondary-headline"},a);case 6:return h("h6",{class:"secondary-headline"},a);default:return h("strong",{class:"secondary-headline"},a)}},this._label=void 0,this._level=1,this._secondaryHeadline=void 0,this._variant=void 0,this.state={_label:"",_level:1}}validateLabel(a){validateLabelWithExpertSlot(this,a)}validateLevel(a){watchHeadingLevel(this,a)}validateSecondaryHeadline(a){watchString(this,"_secondaryHeadline",a)}validateVariant(a){validateHeadingVariant(this,a)}componentWillLoad(){this.validateLabel(this._label),this.validateLevel(this._level),this.validateSecondaryHeadline(this._secondaryHeadline),this.validateVariant(this._variant)}render(){return h(Host,{key:"3a0b2e5eae14d4a7d83b25e806eaf7cda1b52c9a"},"string"==typeof this.state._secondaryHeadline&&this.state._secondaryHeadline.length>0?h("hgroup",null,this.renderHeadline(this.state._label,this.state._level),this.state._secondaryHeadline&&this.renderSecondaryHeadline(this.state._secondaryHeadline,this.state._level+1)):this.renderHeadline(this.state._label,this.state._level))}static get watchers(){return{_label:["validateLabel"],_level:["validateLevel"],_secondaryHeadline:["validateSecondaryHeadline"],_variant:["validateVariant"]}}};export{KolAlertWc as kol_alert_wc,KolButtonWc as kol_button_wc,KolHeadingWc as kol_heading_wc};